package io.dekorate.prometheus.config;

import java.lang.Integer;
import io.dekorate.kubernetes.config.ConfigurationFluentImpl;
import java.lang.StringBuffer;
import com.fasterxml.jackson.annotation.JsonProperty;
import java.lang.StringBuilder;
import java.lang.Object;
import java.lang.String;
import java.lang.Boolean;

public class ServiceMonitorConfigFluentImpl<A extends ServiceMonitorConfigFluent<A>> extends ConfigurationFluentImpl<A> implements ServiceMonitorConfigFluent<A> {

    private String port;
    private String path;
    private Integer interval;
    private Boolean honorLabels;

    public ServiceMonitorConfigFluentImpl() {
    }

    public ServiceMonitorConfigFluentImpl(ServiceMonitorConfig instance) {
        this.withProject(instance.getProject()); 
        this.withAttributes(instance.getAttributes()); 
        this.withPort(instance.getPort()); 
        this.withPath(instance.getPath()); 
        this.withInterval(instance.getInterval()); 
        this.withHonorLabels(instance.getHonorLabels()); 
    }

    public String getPort() {
        return this.port;
    }

    public A withPort(String port) {
        this.port=port; return (A) this;
    }

    public Boolean hasPort() {
        return this.port != null;
    }

    public A withNewPort(String arg1) {
        return (A)withPort(new String(arg1));
    }

    public A withNewPort(StringBuilder arg1) {
        return (A)withPort(new String(arg1));
    }

    public A withNewPort(StringBuffer arg1) {
        return (A)withPort(new String(arg1));
    }

    public String getPath() {
        return this.path;
    }

    public A withPath(String path) {
        this.path=path; return (A) this;
    }

    public Boolean hasPath() {
        return this.path != null;
    }

    public A withNewPath(String arg1) {
        return (A)withPath(new String(arg1));
    }

    public A withNewPath(StringBuilder arg1) {
        return (A)withPath(new String(arg1));
    }

    public A withNewPath(StringBuffer arg1) {
        return (A)withPath(new String(arg1));
    }

    public Integer getInterval() {
        return this.interval;
    }

    public A withInterval(Integer interval) {
        this.interval=interval; return (A) this;
    }

    public Boolean hasInterval() {
        return this.interval != null;
    }

    public Boolean getHonorLabels() {
        return this.honorLabels;
    }

    public A withHonorLabels(Boolean honorLabels) {
        this.honorLabels=honorLabels; return (A) this;
    }

    public Boolean hasHonorLabels() {
        return this.honorLabels != null;
    }

    public A withNewHonorLabels(String arg1) {
        return (A)withHonorLabels(new Boolean(arg1));
    }

    public A withNewHonorLabels(boolean arg1) {
        return (A)withHonorLabels(new Boolean(arg1));
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        if (!super.equals(o)) return false;
        ServiceMonitorConfigFluentImpl that = (ServiceMonitorConfigFluentImpl) o;
        if (port != null ? !port.equals(that.port) :that.port != null) return false;
        if (path != null ? !path.equals(that.path) :that.path != null) return false;
        if (interval != null ? !interval.equals(that.interval) :that.interval != null) return false;
        if (honorLabels != null ? !honorLabels.equals(that.honorLabels) :that.honorLabels != null) return false;
        return true;
    }

    public int hashCode() {
        return java.util.Objects.hash(port,  path,  interval,  honorLabels,  super.hashCode());
    }

}
